//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "myusbfx.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

TmyUsbFx usbFx;     // traC^[tF[Xdy|tra^ewQitbs|QORjpNX


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
// USBI[v
void __fastcall TForm1::Button1Click(TObject *Sender)
{
    usbFx.hUSB = usbFx.OpenDriver("Ezusb-0");

    if ( usbFx.hUSB == INVALID_HANDLE_VALUE ){
        //
        ShowMessage("{[h܂");
        return;
    }

    PCONF pconf;        // [hݒpϐ
    pconf.Mode = CNF_PIO;
    pconf.Brate= CNF_BRATE;
    pconf.PE   = CNF_PDIR_OUT;
    pconf.PD   = CNF_PDIR_OUT;
    pconf.PC   = CNF_PDIR_OUT;
    pconf.PB   = CNF_PDIR_OUT;
    pconf.PA   = CNF_PDIR_IN ;

    int sts = usbFx.EZ_SetPortConfig(pconf);
    if ( !sts ) {
        ShowMessage("샂[hݒ肪ł܂ł");
        return ;
    }

    ShowMessage("I[v");

}
//---------------------------------------------------------------------------
// USBN[Y
void __fastcall TForm1::Button2Click(TObject *Sender)
{
    if ( !usbFx.CloseDriver( usbFx.hUSB ) ){
        ShowMessage("foCXN[YɎs܂");
        return ;
    }
    ShowMessage("N[Y");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
    if ( usbFx.hUSB != INVALID_HANDLE_VALUE ){
        if ( !usbFx.CloseDriver( usbFx.hUSB ) ){
            ShowMessage("foCXN[YɎs܂");
        }
    }
}
//---------------------------------------------------------------------------
// ]
void __fastcall TForm1::Button3Click(TObject *Sender)
{

    int PBDAT = Edit1->Text.ToIntDef(-1);
    int PDDAT = Edit2->Text.ToIntDef(-1);

    if ( PBDAT < 0 ) {
        PBDAT = AnsiString( "0x" + Edit1->Text.Trim() ).ToIntDef(-1);
        if ( PBDAT < 0 || PBDAT > 0xff) {
            ShowMessage("o͒lݒ肪ُłiPBj");
            return ;
        }
    }
    if ( PDDAT < 0  || PDDAT > 0xff) {
        PDDAT = AnsiString( "0x" + Edit2->Text.Trim() ).ToIntDef(-1);
        if ( PDDAT < 0 || PDDAT > 0xff) {
            ShowMessage("o͒lݒ肪ُłiPDj");
            return ;
        }
    }

    usbFx.EZ_PIOWrite(PORTB, PBDAT); //PB
    usbFx.EZ_PIOWrite(PORTD, PDDAT); //PD

}
//---------------------------------------------------------------------------
// l͗p̐
void __fastcall TForm1::EditKeyPress(TObject *Sender, char &Key)
{
    if (( Key<0x30 || 0x39 < Key) && ( Key<0x41 || 0x46 < Key)&& ( Key<0x61 || 0x66 < Key)
        && ( Key!=0x8 ) && ( Key!='x' ) && ( Key!='X' )){
        Key = 0;
        return ;
    }
}
//---------------------------------------------------------------------------
// PA̓ǂݏo
void __fastcall TForm1::Button4Click(TObject *Sender)
{
    //
    int ret = usbFx.EZ_PIORead(PORTA); //PA
    ShowMessage(IntToHex(ret,4));
}
//---------------------------------------------------------------------------

